#!/bin/sh

#
# Copyright (c) 2008-2011 Peter Holm <pho@FreeBSD.org>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $FreeBSD: user/pho/stress2/misc/unionfs2.sh 278504 2015-02-10 12:35:07Z pho $
#

[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1

saved=`sysctl vfs.lookup_shared | awk '{print $NF}'`
for i in 1 0; do
   sysctl vfs.lookup_shared=$i
   [ -d /var/tmp/unionfs ] || mkdir -p /var/tmp/unionfs
   mount_unionfs /var/tmp/unionfs /tmp/stressX

   export RUNDIR=/var/tmp/unionfs/stressX
   export runRUNTIME=10m            # Run tests for 10 minutes
   (cd ..; ./run.sh disk.cfg)
   false
   while mount | grep -q /unionfs; do
      umount /tmp/stressX > /dev/null 2>&1
   done
   rm -rf /var/tmp/unionfs
done
sysctl vfs.lookup_shared=$saved
